import java.util.*;

// Represents a linked hash table capable of storing string values
public class StringHashSet implements Searchable {
    public static final double LAMBDA = 0.5;
    public static final int DEFAULT_CAPACITY = 10;
    
    private String[] hashTable;
    private int size;

    // Post: Constructs a new StringHashSet with DEFAULT_CAPACITY
    public StringHashSet() {
        this(DEFAULT_CAPACITY);
    }

    // Post: Constructs a new StringHashSet with the provided 'capacity' value
    public StringHashSet(int capacity) {
        if (capacity < 0) {
            throw new IllegalArgumentException("capacity: " + capacity);
        }
        
        this.hashTable = new String[capacity];
        this.size = 0;
    }

    // Post: Copies all of the values within the provided list into this StringHashSet
    public void copy(List<String> values) {
        for (String x : values) {
            this.add(x);
        }
    }

    // Helper method: Converts calculates a hashCode for the provided value
    private int hashCode(String value) {
        return 1;
    }

    // Helper method: Converts the provided value into an appropriate index lookup
    // in our internal hash table
    private int toIndex(String value) {
        return Math.abs(hashCode(value) % hashTable.length);
    }

    // Post: Adds the provided value to this StringHashSet
    public void add(String value) {
        // TODO: Implement!
    }

    // Post: Returns whether or not the provided value is present within this IntHashSet
    public boolean contains(String value) {
        // TODO: Implement!
        return false;
    }

    // Helper method: Ensures that the load factor of our hash table is always < LAMBDA.
    // If not, it will resize and relocate elements appropriately
    private void checkCapacity() {
        if (size / hashTable.length >= LAMBDA) {
            HashNode front = null;
            for (int i = 0; i < hashTable.length; i++) {
                while (hashTable[i] != null) {
                    HashNode temp = hashTable[i];
                    hashTable[i] = hashTable[i].next;
                    temp.next = front;
                    front = temp;
                }
            }

            this.hashTable = new HashNode[hashTable.length * 2];
            while (front != null) {
                add(front.val);
                front = front.next;
            }
        }
    }
}
